var tiles3=[
["starve",
"idle",
"granary",
"saved",
"uncult",
"guardlimit",
"fut_hp"]
,
["fut_peasant",
"fut_soldier",
"fut_grain",
"fut_beer",
"fut_land",
"fut_palace",
"palace_cost"]
,
["harvest",
"bonus",
"lost_defend",
"guardremain",
"join",
"submit",
"feed",
"rat",
"income_land",
"income_beer",
"prod",
"dmg"]
];
var rept={"rat":"The rats ate X bushel[s] of grain.",
"set_festival":"The people drank X pot[s] of beer during a huge festival in your honor.",
"starve":"X rebel[s] attacked your palace.",
"lost_defend":"You lost X guard[s].",
"harvest":"Your peasants harvested X bushel[s] of grain from the fields.",
"join":"Seeing the fruits of your enlightened leadership, X new subject[s] joined your kingdom.",
"set_attack":"Your glorious armies conquered X acre[s] of land.",
"submit":"They also subjugated X peasant[s] in the process.",
"set_train":"X new soldier[s were] recruited and trained.",
"prod":"Your brewers produced a total of X pot[s] of beer.",
"set_upgrade":"Your palace was expanded by X guard post[s]."};
var lines=$("#defs").html().split(/\r?\n/);
$("#defs").html("Thanks for playing!");
var tiles=new Array(), vars=new Object(), tiles2=new Object();
var i,tile,op,arg,ops=["+","-","x","/","="];
for (i = 0; i < lines.length; i++) {
	var line=lines[i];
	if (line=="")
		continue;
	line=line.split(" ");
	if (ops.includes(line[0][0])) {
		tile.op.push(op=line.shift());
	} else {
		tile={"op":[op="+"],"arg":new Array(),"desc":new Array()};
		tiles.push(tile);
	}
	arg=line.shift();
	arg=arg[0]=="["?arg.slice(1,-1):arg;
	if (isNaN(parseInt(arg))) {
		/*if (vars[arg]==undefined)
			vars[arg]="x";
		vars[arg]=vars[arg]+(op[0]=="="?" def":" use");*/
		vars[arg]=0;
	}
	tile.arg.push(arg);
	tile.desc.push(line.join(" "));
	if (op[0]=="=")
		tiles2[arg]=tile;
}
/*var x;
for (x in vars) {
	if (x.startsWith("fut_")) {
		if (vars[x.slice(4)]==undefined)
			alert("!!!");
		vars[x.slice(4)]+=" fut";
	}
}*/
var year=1,rand=new Math.seedrandom();
function check() {
	var x;
	for (x in vars) {
		if (vars[x]<0) {
			//alert("nem megy: "+x+"="+vars[x]);
			return false;
		}
	}
	return true;
}
function turn() {
	var x;
	if (!check()) {
		alert("error");
		return;
	}
	var report="";
	for (x in rept) {
		var val=vars[x];
		if (val>0)
			report+=rept[x].replace(/X/,val).replace(/\[s\]/,val>1?"s":"").replace(/\[s were\]/,val>1?"s were":" was")+"\n";
	}
	for (x in vars) {
		if (x.startsWith("fut_"))
			vars[x.slice(4)]=vars[x];
	}
	vars["fertility"]=1 + Math.floor(rand() * 6);
	year+=1;
	frissit();
	alert(report);
}
function prop() {
	if (vars["set_luxury"]<1)
		vars["set_luxury"]=1;
	while (true) {
		var changed=false;
		var t,j;
		for (j=0;j<tiles.length;j++) {
			t=tiles[j];
			var i, x=0;
			for (i=0; i<t.op.length; i++) {
				var op=t.op[i];
				var arg=parseInt(t.arg[i]);
				if (isNaN(arg))
					arg=vars[t.arg[i]];
				if (isNaN(arg))
					arg=1;
				if (op[0]=="+")
					x+=arg;
				if (op[0]=="-")
					x-=arg;
				if (op[0]=="x")
					x*=arg;
				if (op[0]=="/")
					x=arg==0&&op[1]=="F"?0:x/arg;
				if (op[1]=="m")
					x=Math.max(x,0);
				if (op[1]=="f"||op[1]=="F")
					x=Math.floor(x);
				if (op[1]=="c")
					x=Math.ceil(x);
				if (op[0]=="=" && arg!=x) {
					changed=true;
					vars[t.arg[i]]=x;
				}
			}
		}
		if (!changed)
			break;
	}
}
function mutat() {
	/*var t,j,text="";
	for (j=0;j<tiles.length;j++) {
		t=tiles[j];
		text+="<br>";
		var i;
		for (i=0; i<t.op.length; i++) {
			var op=t.op[i];
			var arg=parseInt(t.arg[i]);
			if (isNaN(arg))
				arg=vars[t.arg[i]];
			text+=op[0]+" "+arg+" "+t.desc[i]+"<br>";
		}
	}
	return text;*/
	var t,text;
	var numspace=4, colw=44, maxl=0, sumw=10;
	var summ={"peasant":"peasants","soldier":"soldiers","grain":"grain","beer":"beer","land":"land","palace":"palace","hp":"health"};
	var summ2={"peasant":"starve","soldier":"idle","grain":"granary","beer":"saved","land":"uncult","palace":"guardlimit","hp":"fut_hp"};
	var disp=[[],[],[]];
	var i,j,k,l,x;
	disp[0].push("┌"+"─".repeat(colw*2-3)+"┐");
	disp[0].push('│ This is year '+year+' of your rule. The fields got <span class="fertility">'+["","very poor","poor","below-average","above-average","good","excellent"][vars["fertility"]]+' soil</span> from the last flood.');
	disp[0].push("│");
	
	text="│     resource";
	for (x in summ)
		text+=" ".repeat(sumw-summ[x].length)+summ[x];
	disp[0].push(text);
	
	text="│ unused/total";
	for (x in summ)
		text+=" ".repeat(sumw-(vars[summ2[x]]+"/"+vars[x]).length)+'<span class="'+summ2[x]+'">'+vars[summ2[x]]+'</span>/<span class="'+x+'">'+vars[x]+'</span>';
	disp[0].push(text);
	
	text="│    next year";
	for (x in summ)
		text+=" ".repeat(sumw-(vars["fut_"+x]+"").length)+'<span class="fut_'+x+'">'+vars["fut_"+x]+'</span>';
	disp[0].push(text);
	
	disp[0].push("│");
	disp[0].push("│         "+sumset({"set_farmer":"farmers","set_attack":"attackers","set_festival":"free beer","set_sell_beer":"beer sold"}));
	disp[0].push("│         "+sumset({"set_brewer":"brewers","set_defend":"guards","set_upgrade":"upgrades","set_sell_land":"land sold"}));
	disp[0].push("│         "+sumset({"set_train":"recruits","set_dismiss":"discharged","set_luxury":"luxury"})+'     <span class="'+(check()?'chl endturn':'red')+'">[END TURN]</span>');
	for (i=0; i<disp[0].length; i++)
		disp[1].push("");
	for (i=0; i<3; i++) {
		disp[i].push((i==0?"├":"┌")+"─".repeat(colw-2)+"┐");
		for (j=0; j<tiles3[i].length; j++) {
			t=tiles2[tiles3[i][j]];
			//disp[i].push(" ".repeat(colw));
			//disp[i].push("╔"+"═".repeat(colw-3)+"╗ ");
			if (j>0)
				disp[i].push("├"+"─".repeat(colw-2)+"┤");
			for (k=0; k<t.op.length; k++) {
				var op=t.op[k];
				var arg=parseInt(t.arg[k]);
				if (isNaN(arg))
					arg=vars[t.arg[k]];
				var setarg=(t.arg[k]+"").startsWith("set_"),setspan='<span class="chl up_'+t.arg[k]+'">▲</span><span class="chl down_'+t.arg[k]+'">▼</span>';
				var text=(k==0?" ":op[0])+" ".repeat(Math.max(numspace-(arg+"").length,0))+arg+(setarg?setspan:"  ")+t.desc[k];
				//disp[i].push("║<span"+(isNaN(parseInt(t.arg[k]))?" class=\""+t.arg[k]+(op[0]=="="&&arg<0?" red":"")+"\"":"")+">"+text+" ".repeat(colw-text.length+(setarg?setspan.length-2:0)-3)+"</span>║ ");
				disp[i].push("│<span"+(isNaN(parseInt(t.arg[k]))?" class=\""+t.arg[k]+(op[0]=="="&&arg<0?" red":"")+"\"":"")+">"+text+" ".repeat(colw-text.length+(setarg?setspan.length-2:0)-2)+"</span>│");
			}
			//disp[i].push("╚"+"═".repeat(colw-3)+"╝ ");
		}
		disp[i].push("└"+"─".repeat(colw-2)+"┘");
		if (disp[i].length>maxl)
			maxl=disp[i].length;
	}
	disp[0].push(" Font by VileR - int10h.org");
	text="";
	for (l=0;l<maxl;l++) {
		var row="";
		for (i=0; i<3; i++) {
			//row+=disp[i][l]==undefined?" ".repeat(colw-2):disp[i][l];
			if (disp[i][l]!=undefined)
				row+=disp[i][l];
			row+=" ".repeat(Math.max(0,(colw-1)*(i+1)-vl(row)));
		}
		text+=row.replace(/││/g,"│").replace(/┤│/g,"┤").replace(/│┌/g,"├").replace(/┐│/g,"┤").replace(/│├/g,"├").replace(/┘│/g,"┤").replace(/│└/g,"├").replace(/┤├/g,"┼").replace(/┐┌/g,"┬").replace(/┘└/g,"┴")+"<br>";
	}
	return text;//+"a<br>"+"a<br>"+"a<br>g";
}
function vl(s) {
	var ret=0,b=1,i;
	for (i=0;i<s.length;i++) {
		if (s[i]=="<")
			b=0;
		ret+=b;
		if (s[i]==">")
			b=1;
	}
	return ret;
}
function frissit() {
	prop();
	$("#d").html(mutat());
	var x;
	for (x in vars) {
		$("span."+x).mouseover(eval('(function(){$("span.'+x+'").addClass("hl")})'));
		$("span."+x).mouseout(eval('(function(){$("span.'+x+'").removeClass("hl")})'));
		if (x.startsWith("set_")) {
			$("span.up_"+x).on('click',eval('(function(){vars["'+x+'"]+=1;frissit();})'));
			$("span.down_"+x).on('click',eval('(function(){if(vars["'+x+'"]==0)return;vars["'+x+'"]-=1;frissit();})'));
		}
	}
	$("span.endturn").click(turn);
}
function sumset(par) {
	var numspace=4;
	var x,text2="";
	for (x in par) {
		var arg=vars[x];
		var setspan='<span class="chl up_'+x+'">▲</span><span class="chl down_'+x+'">▼</span>';
		var text=" ".repeat(Math.max(numspace-(arg+"").length,0))+arg+setspan+par[x];
		text2+='<span class="'+x+'">'+text+" ".repeat(16-text.length+setspan.length-2)+"</span>";
	}
	return text2;
}
var seed0=rand().toString(36).substring(2);
var seed=prompt("This random seed will determine soil fertility each year.",seed0);
if (seed===null)
	seed=seed0;
rand=new Math.seedrandom(seed);
vars["hp"]=99;
vars["palace"]=1;
vars["soldier"]=1;
vars["grain"]=5;
vars["land"]=2;
vars["peasant"]=3;
vars["beer"]=0;
vars["fertility"]=1 + Math.floor(rand() * 6);
frissit();
//$("#d").html(JSON.stringify(vars).replace(/,/g,",<br>"));








